---
title: Recipes
permalink: /recipes
category: Examples & Tutorials
---

These recipes will show you the best practices of using Cube.js.

### <--{"id" : "Recipes"}--> Analytics

- [Calculating daily, weekly, monthly active users](/recipes/active-users)
- [Implementing event analytics](/recipes/event-analytics)
- [Implementing funnel analysis](/recipes/funnels)
- [Implementing retention analysis & cohorts](/recipes/cohort-retention)

### <--{"id" : "Recipes"}--> Access control

- [Enforcing role-based access](/recipes/role-based-access)
- [Enforcing column-based access](/recipes/column-based-access)
- [Enforcing mandatory filters](/recipes/enforcing-mandatory-filters)

### <--{"id" : "Recipes"}--> Data sources

- [Using multiple data sources](/recipes/multiple-sources-same-schema)
- [Using SSL connections to a data source](/recipes/enable-ssl-connections-to-database)
- [Joining data from multiple data sources](/recipes/joining-multiple-data-sources)


### <--{"id" : "Recipes"}--> Data schema

- [Calculating average and percentiles](https://cube.dev/docs/recipes/percentiles)
- [Implementing data snapshots](/recipes/snapshots)
- [Implementing Entity-Attribute-Value model](/recipes/entity-attribute-value)
- [Using different schemas for tenants](/recipes/using-different-schemas-for-tenants)
- [Using dynamic measures](/recipes/referencing-dynamic-measures)
- [Using dynamic union tables](/recipes/dynamically-union-tables)

### <--{"id" : "Recipes"}--> Queries

- [Getting unique values for a field](/recipes/getting-unique-values-for-a-field)
- [Implementing pagination](/recipes/pagination)
- [Passing dynamic parameters in a query](/recipes/passing-dynamic-parameters-in-a-query)

### <--{"id" : "Recipes"}--> Query acceleration

- [Accelerating non-additive measures](/recipes/non-additivity)
- [Using originalSql and rollup pre-aggregations effectively](/recipes/using-originalsql-and-rollups-effectively)
- [Incrementally building pre-aggregations for a date range](/recipes/incrementally-building-pre-aggregations-for-a-date-range)

### <--{"id" : "Recipes"}--> Code reusability

- [Implementing schema generation](/recipes/schema-generation)

### Integrations

- [Using Apache Superset with Cube SQL API](/recipes/using-apache-superset-with-cube-sql)